<?php
function writelog( $string ) {
	global $text, $currentuser, $currentuserdesc, $cms, $rootpath, $_SERVER, $time_offset, $gotlastpage;
	global $tree, $tngdomain;
	
	require($cms[tngpath] . "logconfig.php");

	$_SESSION['lastpage'] = $string;
	$gotlastpage = true;
	$remhost = getenv( "REMOTE_HOST" );
	if( !$remhost ) {
		$remhost = $_SERVER['REMOTE_HOST'];
		if( !$remhost ) {
			$remip = getenv("REMOTE_ADDR");
			if( !$remip ) $remip = $_SERVER['REMOTE_ADDR'];
			$remhost = @gethostbyaddr( $remip );
			if( !$remhost ) $remhost = $remip;
		}
	}

	if( $badhosts && $remhost ) {
		$terms = explode(",", $badhosts);
		foreach( $terms as $term ) {
			if( $term ) {
				// if( strstr( $remhost, trim($term) ) )
				// next line modified Sep 24, 2006 to support IP filtering as well
				if( (strstr( $remhost, trim($term) )) || (strstr ($remip, trim($term))) || (strstr($currentuserdesc, trim($term))) )
					return;
			}
		}
	}

	if( $cms[support] && $currentuser )
		$string .= xmlcharacters(" $text[accessedby] $text[user]") . ": $currentuser";
	else {
		$string .= xmlcharacters(" $text[accessedby]") . " $remhost";
		if( $currentuser ) $string .= " (" . xmlcharacters($text[user]) . ": $currentuserdesc)";
	}



// ---------------------------------------------------
// This section added Jun 3, 2006
// The referer info is cleaned up before appending.
// Some of this will be dependent on your specific preferences
//
	$referer = getenv('HTTP_REFERER'); 
	$referer = str_replace("&tree=$tree","",$referer);
	$referer = str_replace($tngdomain,".",$referer);
	$referer = str_replace("&&","&",$referer);
	$referer = str_replace("&amp;$","",$referer);


// It appends the referrer page info to the log line

  if ($referer != '') { 
     $string .= " from " . trim(strip_tags(htmlspecialchars($referer))); 
  } 
  if( strlen($string) > 400 ) $string = substr($string,0,400);
  
// ----------------------------------------------------

// ----------------------------------------------------
// Added Jun 5, 2006
// Section added or modified to direct robot page accesses to an alternate log file
// This section can be added to as more bots are noticed in the regular log
// The name of the alternate log is set as   botgenlog.txt
// Don't forget to ensure the permissions are set for full read/write access or you'll get a file
// access error when users access the page
//
// A link to the page to access this new log is on the regular log file display page
//
//
	if (strpos($remhost,"google") !== false || 
		strpos($remhost,"msnbot") !== false || 
		strpos($remhost,"inktomi") !== false || 
		strpos($remhost,"werelate") !== false || 
		strpos($remhost,"Panscient") !== false || 
		strpos($remhost,"gigablast") !== false )
		{
			$thefile = "botgenlog.txt";
		} else {
			$thefile = $logfile;
		}

	$lines = file( $thefile );
	if( $maxloglines && sizeof( $lines ) >= $maxloglines ) {
		array_pop( $lines );
	}
	$updated = date ("D d M Y h:i:s A", time() + ( 3600 * $time_offset ) );
	array_unshift( $lines, "$updated $string.\n" );
	
	
	$fp = @fopen( $thefile, "w" );
	if( !$fp ) { die ( "Cannot open $thefile" ); }
// ------------------------------------------------------


	flock( $fp, LOCK_EX );
	$linecount = 0;
	foreach ( $lines as $line ) {
		trim( $line );
		if( $line )
			fwrite( $fp, $line );
		$linecount++;
		if( $linecount == $maxloglines ) break;
	}
	flock( $fp, LOCK_UN );
	fclose( $fp );
}
?>
